std::reverse_iterator< _Iterator >(3)

NAME
std::reverse_iterator< _Iterator >

SYNOPSIS

Inherits std::iterator< iterator_traits< _Iterator >::iterator_category, iterator_traits< _Iterator >::value_type, iterator_traits< _Iterator >::difference_type, iterator_traits< _Iterator >::pointer, iterator_traits< _Iterator >::reference >.

  Public Types
typedef __traits_type::difference_type difference_type
typedef iterator_traits< _Iterator >::iterator_category iterator_category
One of the tag types.
typedef _Iterator iterator_type
typedef __traits_type::pointer pointer
typedef __traits_type::reference reference
typedef iterator_traits< _Iterator >::value_type value_type
The type 'pointed to' by the iterator.

  Public Member Functions
constexpr reverse_iterator ()
constexpr reverse_iterator (const reverse_iterator &__x)
template<typename _Iter > constexpr reverse_iterator (const reverse_iterator< _Iter > &__x)
constexpr reverse_iterator (iterator_type __x)
constexpr iterator_type base () const
constexpr reference operator* () const
constexpr reverse_iterator operator+ (difference_type __n) const
constexpr reverse_iterator & operator++ ()
constexpr reverse_iterator operator++ (int)
constexpr reverse_iterator & operator+= (difference_type __n)
constexpr reverse_iterator operator- (difference_type __n) const
constexpr reverse_iterator & operator-- ()
constexpr reverse_iterator operator-- (int)
constexpr reverse_iterator & operator-= (difference_type __n)
constexpr pointer operator-> () const
reverse_iterator & operator= (const reverse_iterator &)=default
constexpr reference operator[] (difference_type __n) const

  Protected Types
typedef iterator_traits< _Iterator > __traits_type

  Protected Attributes
_Iterator current

Detailed Description

  template<typename _Iterator>
class std::reverse_iterator< _Iterator >" Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator i is established by the identity:

&*(reverse_iterator(i)) == &*(i - 1)

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array. [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Definition at line 125 of file bits/stl_iterator.h.

Member Typedef Documentation

  typedef iterator_traits< _Iterator >::iterator_category std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::iterator_category [inherited]

One of the tag types.

Definition at line 130 of file stl_iterator_base_types.h.

  typedef iterator_traits< _Iterator >::value_type std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::value_type [inherited]

The type 'pointed to' by the iterator.

Definition at line 132 of file stl_iterator_base_types.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.